"use strict";

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _server = require("react-dom/server");

var _reactFela = require("react-fela");

var _fela = require("fela");

var _felaDom = require("fela-dom");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.replaceRenderer = function (_ref, pluginOptions) {
  var bodyComponent = _ref.bodyComponent,
      replaceBodyHTMLString = _ref.replaceBodyHTMLString,
      setHeadComponents = _ref.setHeadComponents;

  var renderer = (0, _fela.createRenderer)(pluginOptions.config);
  var theme = pluginOptions.theme || {};
  var bodyHTML = (0, _server.renderToString)(_react2.default.createElement(
    _reactFela.Provider,
    { renderer: renderer },
    _react2.default.createElement(
      _reactFela.ThemeProvider,
      { theme: theme },
      bodyComponent
    )
  ));
  var sheetList = (0, _felaDom.renderToSheetList)(renderer);
  var elements = sheetList.map(function (_ref2) {
    var type = _ref2.type,
        css = _ref2.css,
        media = _ref2.media,
        support = _ref2.support;
    return _react2.default.createElement("style", {
      dangerouslySetInnerHTML: { __html: css },
      "data-fela-type": type,
      "data-fela-support": support,
      key: type + "-" + media,
      media: media
    });
  });
  replaceBodyHTMLString(bodyHTML);
  setHeadComponents(elements);
};